<?php 
/* Оплата через WebMoney */
class system_of_pay_handler
{
	/* Кошельки */
	var $wmr = 'R123456789123';
	var $wmz = 'Z123456789123';

	/* Определяем валюты для WMR и WMZ */
	var $wmr_currency_id = 1;
	var $wmz_currency_id = 3;

	/* Определяем коэффициенты перерасчета для WMR и WMZ */
	var $wmr_coefficient_id = 1;
	var $wmz_coefficient_id = 1;

	/* Секретные ключи для кошельков, должны совпадать с настройками
	на https://merchant.webmoney.ru/conf/purses.asp */
	var $wmr_secret_key = 'hostmake';
	var $wmz_secret_key = 'hostmake';

	/**
	 * Обработка статуса оплаты
	 *
	 */
	function ProcessResult()
	{
		/* Информация о заказе */
		$order_id = to_int($_POST['order_id']);

		if (!$order_id)
		{
			return false;
		}

		$shop = & singleton('shop');

		$order_row = $shop->GetOrder($order_id);

		if (!$order_row)
		{
			return false;
		}

		$shop_row = $shop->GetShop($order_row['shop_shops_id']);
		
		/* В зависимости от типа кошелька выбираем Secret Key */
		switch (to_int($_POST['purse']))
		{
			case 1: /* WMR */
			{
				$secret_key = $this->wmr_secret_key;
				$currency_name = "WMR";
				break;
			}
			case 2: /* WMZ */
			{
				$secret_key = $this->wmz_secret_key;
				$currency_name = "WMZ";
				break;
			}
			default:
				{
					return false;
				}
		}

		/* Проверяем целостность данных */
		$str = to_str($_POST['LMI_PAYEE_PURSE']).
		to_str($_POST['LMI_PAYMENT_AMOUNT']).
		to_str($_POST['LMI_PAYMENT_NO']).
		to_str($_POST['LMI_MODE']).
		to_str($_POST['LMI_SYS_INVS_NO']).
		to_str($_POST['LMI_SYS_TRANS_NO']).
		to_str($_POST['LMI_SYS_TRANS_DATE']).
		$secret_key.
		to_str($_POST['LMI_PAYER_PURSE']).
		to_str($_POST['LMI_PAYER_WM']);

		/*
		if (trim($str) == '')
		{
		return false;
		}
		*/

		$str = md5($str);

		/* Устанавливаем параметры */
		$param['id'] = $order_row['shop_order_id'];
		$param['shop_shops_id'] = $order_row['shop_shops_id'];
		$param['location_id'] = $order_row['shop_location_id'];
		$param['country_id'] = $order_row['shop_country_id'];
		$param['shop_city_id'] = $order_row['shop_city_id'];
		$param['city_area_id'] = $order_row['shop_city_area_id'];
		$param['shop_cond_of_delivery_id'] = $order_row['shop_cond_of_delivery_id'];
		$param['delivery_price'] = $order_row['shop_order_delivery_price'];
		$param['site_user_id'] = $order_row['site_users_id'];
		$param['shop_order_status_id'] = $order_row['shop_order_status_id'];
		$param['currency_id'] = $order_row['shop_currency_id'];
		$param['shop_system_of_pay_id'] = $order_row['shop_system_of_pay_id'];
		$param['order_date_time'] = $order_row['shop_order_date_time'];
		$param['status_of_pay'] = $order_row['shop_order_status_of_pay'];
		$param['date_of_pay'] = $order_row['shop_order_date_of_pay'];
		$param['address'] = $order_row['shop_order_address'];
		$param['index'] = $order_row['shop_order_index'];
		$param['phone'] = $order_row['shop_order_phone'];
		$param['description'] = $order_row['shop_order_description'];

		/* Сравниваем хэши */
		if (strtoupper($str) == strtoupper(to_str($_POST['LMI_HASH'])))
		{
			/* Проверка прошла успешно!
			Добавляем комментарий */
			$param['system_information'] = "Товар оплачен через WebMoney.\n".
			"Атрибуты:\n".
			"Кошелек продавца: {$_POST['LMI_PAYEE_PURSE']}\n".
			"Сумма: {$_POST['LMI_PAYMENT_AMOUNT']} {$currency_name}\n".
			"Номер покупки: {$_POST['LMI_PAYMENT_NO']}\n".
			"Режим (0 - реальный, 1 - тестовый): {$_POST['LMI_MODE']}\n".
			"Номер счета для покупателя: {$_POST['LMI_SYS_INVS_NO']}\n".
			"Номер платежа: {$_POST['LMI_SYS_TRANS_NO']}\n".
			"Кошелек покупателя: {$_POST['LMI_PAYER_PURSE']}\n".
			"WM-идентификатор покупателя: {$_POST['LMI_PAYER_WM']}";

			/* Устанавливаем признак оплаты */
			$param['date_of_pay'] = date("Y-m-d H:i:s");
			$param['status_of_pay'] = true;
		}
		else
		{
			$param['system_information'] = 'WM хэш не совпал!';
		}

		// Обновляем информацию о заказе
		$shop->InsertOrder($param);
		
		// Отправку письма об оплате делаем только после вставки информации об оплате
		if (strtoupper($str) == strtoupper(to_str($_POST['LMI_HASH'])))
		{
			$structure = & singleton('Structure');
			$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

			$lib = new lib();
			$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

			// Отправляем письмо администратору о подтверждении платежа
			$shop->SendMailAboutOrder($order_row['shop_shops_id'], $order_id, $order_row['site_users_id'],
			to_str($LA['xsl_letter_to_admin']),
			to_str($LA['xsl_letter_to_user']),
			$order_row['shop_order_users_email'],
			array(
			'admin-content-type' => 'html',
			'user-content-type' => 'html',
			'admin-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_confirm_admin_subject'], $order_id, $shop_row['shop_shops_name'], $param['date_of_pay']),
			'user-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_confirm_user_subject'], $order_id, $shop_row['shop_shops_name'], $param['date_of_pay'])));
		}
	}

	/**
	 * Отображает стартовую страницу для оплаты через Web Money.
	 *
	 */
	function ShowPurseRequest()
	{
		$shop_id = to_int($GLOBALS['shop_id']);

		/* Получаем id текущего пользователя сайта */
		if (class_exists('SiteUsers'))
		{
			/* Получаем id текущего пользователя сайта */
			$SiteUsers = & singleton('SiteUsers');
			$site_users_id = $SiteUsers->GetCurrentSiteUser();
		}
		else
		{
			$site_users_id = false;
		}

		$shop = & singleton('shop');

		/* ID платежной системы берем из сессии */
		$system_of_pay_id = to_int($_SESSION['system_of_pay_id']);

		// статус платежа, по умолчанию 0
		$order_row['status_of_pay'] = 0 ;

		// дата платежа, по умолчанию пустая строка
		$order_row['date_of_pay'] = '';

		// описание и системная информация, по умолчанию пустая строка
		if (to_str($_SESSION['shop_coupon_text']) != '')
		{
			$order_row['description'] = "Купон на скидку: ".to_str($_SESSION['shop_coupon_text'])."\n";
		}
		else
		{
			$order_row['description'] = '';
		}

		/* Оформляем заказ */
		$order_id = $shop->ProcessOrder($shop_id, $site_users_id, $system_of_pay_id,
		$order_row);

		if ($order_id > 0)
		{
			if (!class_exists('SiteUsers'))
			{
				/* Класс пользователей сайта не существует, дописываем информацию о заказчике
				в поле shop_order_description из текущей сессии */
				if ($order_row)
				{
					/* E-Mail заказчика */
					$user_email = trim(to_str($_SESSION['site_users_email']));

					/* Описание заказчика */
					$order_row['description'] .= "Информация о заказчике:\n"
					."Имя: ".to_str($_SESSION['site_users_name'])."\n"
					."Фамилия: ".to_str($_SESSION['site_users_surname'])."\n"
					."Отчество: ".to_str($_SESSION['site_users_patronymic'])."\n"
					."E-Mail: ".to_str($_SESSION['site_users_email'])."\n"
					."Телефон: ".to_str($_SESSION['site_users_phone'])."\n"
					."Факс: ".to_str($_SESSION['site_users_fax'])."\n"
					."Адрес: ".to_str($_SESSION['site_users_address'])."\n";
					
					/* Обязательно добавляем идентификатор! */
					$order_row['id'] = $order_id;

					$shop->InsertOrder($order_row);
				}
			}
			else
			{
				$user_email = false;
			}

			if ($order_row)
			{
				$shop_row = $shop->GetShop($GLOBALS['shop_id']);

				/* Делаем перерасчет суммы в валюты, выбранные для WebMoney */
				$shop_currency_id = $shop_row['shop_currency_id'];

				/* Для WMR */
				$coefficient = $shop->GetCurrencyCoefficientToShopCurrency($shop_currency_id, $this->wmr_currency_id);
				$wmr_sum = round($order_row['sum'] * $coefficient * $this->wmr_coefficient_id, 2);

				/* Для WMZ */
				$coefficient = $shop->GetCurrencyCoefficientToShopCurrency($shop_currency_id, $this->wmz_currency_id);
				$wmz_sum = round($order_row['sum'] * $coefficient * $this->wmz_coefficient_id, 2);

				/* Информация об алиасе сайта */
				$site = & singleton ('site');
				$site_alias = $site->GetCurrentAlias($shop_row['site_id']);

				/* Получаем путь к магазину */
				$Structure = & singleton('Structure');
				$shop_path = "/".$Structure->GetStructurePath($shop_row['structure_id'], 0);

				$handler_url = 'http://'.$site_alias.$shop_path.'cart/';

				?>
				<h1>Оплата через систему WebMoney</h1>
				<!-- Форма для оплаты через WMR -->
				<p>К оплате <strong><?php echo $wmr_sum?> WMR</strong></p>
				<form id="pay" name="pay" method="post" action="https://merchant.webmoney.ru/lmi/payment.asp">
					<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="<?php echo $wmr_sum?>">
					<input type="hidden" name="LMI_PAYMENT_DESC" value="Оплата счета N <?php echo $order_id?> через WMR">
					<input type="hidden" name="LMI_PAYMENT_NO" value="<?php echo $order_id?>">
					<input type="hidden" name="LMI_PAYEE_PURSE" value="<?php echo $this->wmr?>">
					<input type="hidden" name="LMI_SIM_MODE" value="0">
					<input type="hidden" name="LMI_RESULT_URL" value="<?php echo $handler_url?>">
					<input type="hidden" name="LMI_SUCCESS_URL" value="<?php echo $handler_url."?order_id={$order_id}&payment=success"?>">
					<input type="hidden" name="LMI_SUCCESS_METHOD" value="POST">
					<input type="hidden" name="LMI_FAIL_URL" value="<?php echo $handler_url."?order_id={$order_id}&payment=fail"?>">
					<input type="hidden" name="LMI_FAIL_METHOD" value="POST">
					<input type="hidden" name="step_4" value="1">
					<input type="hidden" name="system_of_pay_id" value="<?php echo $system_of_pay_id?>">
					<input type="hidden" name="order_id" value="<?php echo $order_id?>">
					<input type="hidden" name="purse" value="1">
					<input type="submit" name="submit" value="Перейти к оплате в WMR">
				</form>
				<!-- Форма для оплаты через WMZ -->
				<p>К оплате <strong><?php echo $wmz_sum?> WMZ</strong></p>
				<form id="pay" name="pay" method="post" action="https://merchant.webmoney.ru/lmi/payment.asp">
					<input type="hidden" name="LMI_PAYMENT_AMOUNT" value="<?php echo $wmz_sum?>">
					<input type="hidden" name="LMI_PAYMENT_DESC" value="Оплата счета N <?php echo $order_id?> через WMZ">
					<input type="hidden" name="LMI_PAYMENT_NO" value="<?php echo $order_id?>">
					<input type="hidden" name="LMI_PAYEE_PURSE" value="<?php echo $this->wmz?>">
					<input type="hidden" name="LMI_SIM_MODE" value="0">
					<input type="hidden" name="LMI_RESULT_URL" value="<?php echo $handler_url?>">
					<input type="hidden" name="LMI_SUCCESS_URL" value="<?php echo $handler_url."?order_id={$order_id}&payment=success"?>">
					<input type="hidden" name="LMI_SUCCESS_METHOD" value="POST">
					<input type="hidden" name="LMI_FAIL_URL" value="<?php echo $handler_url."?order_id={$order_id}&payment=fail"?>">
					<input type="hidden" name="LMI_FAIL_METHOD" value="POST">
					<input type="hidden" name="step_4" value="1">
					<input type="hidden" name="system_of_pay_id" value="<?php echo $system_of_pay_id?>">
					<input type="hidden" name="order_id" value="<?php echo $order_id?>">
					<input type="hidden" name="purse" value="2">
					<input type="submit" name="submit" value="Перейти к оплате в WMZ">
				</form>
				<?php 
			}

			$structure = & singleton('Structure');
			$structure_row = $structure->GetStructureItem(to_int($shop_row['structure_id']));

			$lib = new lib();
			$LA = $lib->LoadLibPropertiesValue(to_int($structure_row['lib_id']), to_int($structure_row['structure_id']));

			$date_str = date("d.m.Y H:i:s");

			/* Отправляем письмо заказчику */
			$shop->SendMailAboutOrder($shop_id,
			$order_id,
			$site_users_id,
			to_str($LA['xsl_letter_to_admin']),
			to_str($LA['xsl_letter_to_user']),
			$user_email,
			array('admin-content-type' => 'html',
			'user-content-type' => 'html',
			'admin-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_admin_subject'], $order_id, $shop_row['shop_shops_name'], $date_str),
			'user-subject' => sprintf($GLOBALS['MSG_shops']['shop_order_user_subject'], $order_id, $shop_row['shop_shops_name'], $date_str)));
		}
		else
		{
			switch ($order_id)
			{
				case -1:
					{
						echo "Ошибка вставки заказа в базу данных. Обратитесь к администратору.";
						break;
					}
				case -2:
					{
						echo "Ошибка - не найден магазин. Обратитесь к администратору.";
						break;
					}
			}
		}
	}

	/**
	 * Метод, запускающий выполнение обработчика
	 */
	function Execute()
	{
		/* Пришло подтверждение оплаты, обработаем его */
		if (isset($_POST['LMI_PAYEE_PURSE']))
		{
			$this->ProcessResult();
			return true;
		}

		/* Иначе оформляем заказ и отображаем стартовую страницу для оплаты через WebMoney */
		$this->ShowPurseRequest();
	}

	/**
	 * Метод для отображения формы заказа для печати.
	 *
	 * @param int $order_id идентификатор заказа
	 */
	function PrintOrder($order_id)
	{

	}
	
/**
	 * Изменение статуса заказа. Позволяет пользователю внедрять собственные
	 * обработчики при изменении статуса.
	 * 
	 * @param array $param массив атрибутов
	 * - $param['shop_order_id'] идентификатор заказа
	 * - $param['action'] выполняемое действие над заказом, может принимать
	 * значения: edit (редактирование товара), cancel (отмена заказ),
	 * status (изменение статуса заказа), delete (удаление заказа)
	 */
	function ChangeStatus($param = array())
	{
		
	}
}
?>